﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
/**********************************************************************************
    WaterSimDCDC Regional Water Demand and Supply Model
	Version 5.0

	openTablenameDialog Version 5.6 7/25/11  Quay

    Copyright (C) 2011 , The Arizona Board of Regents
	on behalf of Arizona State University
	
    All rights reserved.

	Developed by the Decision Center for a Desert City
	Lead Model Development - David Sampson <dasamps1@asu.edu>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Dilaog for selecting or specifying a new table in a database.


 *******************************************************************************/
namespace WaterSimDCDC
{
    public partial class TablenameDialog : Form
    {  
        private OleDbConnection _dbConnect;
        private Boolean orgOpen = false;
        private string _TableName = "";
        private bool _newTable = false;
        private bool _isNew = false;
        private List<string> _tablenames = new List<string>();
        private bool _caseSensitive = false;
        private bool _MustExist = false;
       
        //-----------------------------------------------------------------
        public string Tablename { get { return _TableName; } }
        public string Title { get { return this.Text; } set { this.Text = value; } }
        public bool RequireUniqueTablename { get { return _newTable; } set { _newTable = value; } }
        public bool isNewTablename { get { return _isNew; } }
        public bool isCaseSensitive { get { return _caseSensitive; } set { _caseSensitive = value; } }
        public bool TablenameMustExist { get { return _MustExist; } set { _MustExist = value; } }
        //-----------------------------------------------------------------
        public TablenameDialog()
        {
            InitializeComponent();
        }

        //-----------------------------------------------------------------
        public OleDbConnection dbConnect
        {
            //get { return _dbConnect; }
            set
            {
                string Tablename = "";
                _dbConnect = value;
                orgOpen = (_dbConnect.State == System.Data.ConnectionState.Open);
                try
                {
                    if (!orgOpen) _dbConnect.Open();
                    DataSetInfoLabel.Text = _dbConnect.DataSource.ToString();
                    DataTable dbSchema = new DataTable();
                    dbSchema = _dbConnect.GetSchema("TABLES");
                    for (int i = 0; i < dbSchema.Rows.Count; i++)
                    {
                        if (dbSchema.Rows[i]["TABLE_TYPE"].ToString() == "TABLE")
                        {
                            Tablename = dbSchema.Rows[i]["TABLE_NAME"].ToString();
                            TablenameComboBox.Items.Add(Tablename);
                            if (!_caseSensitive)  { Tablename = Tablename.ToUpper(); }
                            _tablenames.Add(Tablename);
 
                        }
                    }
                }
                catch(Exception)
                {
                    throw(new Exception("OleDbConnection failed"));
                }
            }
        }
        //-----------------------------------------------------------------
        public DialogResult ShowDialog( OleDbConnection Connection, bool RequireUnique, bool MustExist) {
            _dbConnect = Connection;
            orgOpen = (_dbConnect.State == System.Data.ConnectionState.Open);
            RequireUniqueTablename = RequireUnique;
            TablenameMustExist = MustExist;
            try
            {
                string temp = "";
                if (!orgOpen) _dbConnect.Open();
                TablenameComboBox.Items.Clear();
                _tablenames.Clear();
                DataSetInfoLabel.Text = _dbConnect.DataSource.ToString();
                DataTable dbSchema = new DataTable();
                dbSchema = _dbConnect.GetSchema("TABLES");
                for (int i = 0; i < dbSchema.Rows.Count; i++)
                {
                    if (dbSchema.Rows[i]["TABLE_TYPE"].ToString() == "TABLE")
                    {
                        temp = dbSchema.Rows[i]["TABLE_NAME"].ToString();
                         TablenameComboBox.Items.Add(temp);
                         _tablenames.Add(temp);
                    }
                }
                return ShowDialog();
            }
            catch (Exception)
            {
                return DialogResult.Abort;
            }

        }
        //--------------------------------------------------------------
        private bool Contains(string value)
        {
            bool isIn = false;
            value = value.ToUpper();
            isIn = (_tablenames.Find(delegate(string findme) { if (findme == value) return true; else return false; }) == value);

            return isIn;
        }
        //--------------------------------------------------------------
        private void TablenameComboBox_TextChanged(object sender, EventArgs e)
        {
                _TableName = TablenameComboBox.Text;
        }
        //--------------------------------------------------------------

        private void OKButton_Click(object sender, EventArgs e)
        {
            _isNew = !Contains(_TableName);

            if ((_newTable) & (!_isNew)) { MessageBox.Show("Tablename must be unique!  " + _TableName + " is an existing table in the database."); }
            else
                if ((_MustExist) & (_isNew)) { MessageBox.Show("Tablename must exist!  " + _TableName + " is not an existing table in the database."); }
            else
            {
                this.DialogResult = System.Windows.Forms.DialogResult.OK;
                this.Close();
            }
        }
        //-----------------------------------------------------------------

    }
}
